--- linux-linaro-3.4-2012.05-1_original/fs/yaffs2/yaffs_guts.c	2012-05-23 00:39:37.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/fs/yaffs2/yaffs_guts.c	2014-07-29 17:28:38.819972000 +0800
@@ -3763,19 +3636,17 @@
 						      local_buffer,
 						      n_writeback, 0);
 
-				yaffs_release_temp_buffer(dev, local_buffer,
-							  __LINE__);
-
+				yaffs_release_temp_buffer(dev, local_buffer);
 			}
-
 		} else {
-			/* A full chunk. Write directly from the supplied buffer. */
+			/* A full chunk. Write directly from the buffer. */
 
 			chunk_written =
 			    yaffs_wr_data_obj(in, chunk, buffer,
 					      dev->data_bytes_per_chunk, 0);
 
-			/* Since we've overwritten the cached data, we better invalidate it. */
+			/* Since we've overwritten the cached data,
+			 * we better invalidate it. */
 			yaffs_invalidate_chunk_cache(in, chunk);
 		}
 
@@ -3785,7 +3656,6 @@
 			buffer += n_copy;
 			n_done += n_copy;
 		}
-
 	}
 
 	/* Update file object */
@@ -3794,31 +3664,38 @@
 		in->variant.file_variant.file_size = (start_write + n_done);
 
 	in->dirty = 1;
-
 	return n_done;
 }
 
-int yaffs_wr_file(struct yaffs_obj *in, const u8 * buffer, loff_t offset,
-		  int n_bytes, int write_trhrough)
+int yaffs_wr_file(struct yaffs_obj *in, const u8 *buffer, loff_t offset,
+		  int n_bytes, int write_through)
 {
 	yaffs2_handle_hole(in, offset);
-	return yaffs_do_file_wr(in, buffer, offset, n_bytes, write_trhrough);
+	return yaffs_do_file_wr(in, buffer, offset, n_bytes, write_through);
 }
 
 /* ---------------------- File resizing stuff ------------------ */
 
-static void yaffs_prune_chunks(struct yaffs_obj *in, int new_size)
+static void yaffs_prune_chunks(struct yaffs_obj *in, loff_t new_size)
 {
 
 	struct yaffs_dev *dev = in->my_dev;
-	int old_size = in->variant.file_variant.file_size;
-
-	int last_del = 1 + (old_size - 1) / dev->data_bytes_per_chunk;
-
-	int start_del = 1 + (new_size + dev->data_bytes_per_chunk - 1) /
-	    dev->data_bytes_per_chunk;
+	loff_t old_size = in->variant.file_variant.file_size;
 	int i;
 	int chunk_id;
+	u32 dummy;
+	int last_del;
+	int start_del;
+
+	if (old_size > 0)
+		yaffs_addr_to_chunk(dev, old_size - 1, &last_del, &dummy);
+	else
+		last_del = 0;
+
+	yaffs_addr_to_chunk(dev, new_size + dev->data_bytes_per_chunk - 1,
+				&start_del, &dummy);
+	last_del++;
+	start_del++;
 
 	/* Delete backwards so that we don't end up with holes if
 	 * power is lost part-way through the operation.
@@ -3830,23 +3707,23 @@
 		 */
 
 		chunk_id = yaffs_find_del_file_chunk(in, i, NULL);
-		if (chunk_id > 0) {
-			if (chunk_id <
-			    (dev->internal_start_block *
-			     dev->param.chunks_per_block)
-			    || chunk_id >=
-			    ((dev->internal_end_block +
-			      1) * dev->param.chunks_per_block)) {
-				yaffs_trace(YAFFS_TRACE_ALWAYS,
-					"Found daft chunk_id %d for %d",
-					chunk_id, i);
-			} else {
-				in->n_data_chunks--;
-				yaffs_chunk_del(dev, chunk_id, 1, __LINE__);
-			}
+
+		if (chunk_id < 1)
+			continue;
+
+		if (chunk_id <
+		    (dev->internal_start_block * dev->param.chunks_per_block) ||
+		    chunk_id >=
+		    ((dev->internal_end_block + 1) *
+		      dev->param.chunks_per_block)) {
+			yaffs_trace(YAFFS_TRACE_ALWAYS,
+				"Found daft chunk_id %d for %d",
+				chunk_id, i);
+		} else {
+			in->n_data_chunks--;
+			yaffs_chunk_del(dev, chunk_id, 1, __LINE__);
 		}
 	}
-
 }
 
 void yaffs_resize_file_down(struct yaffs_obj *obj, loff_t new_size)
@@ -3861,7 +3738,7 @@
 
 	if (new_partial != 0) {
 		int last_chunk = 1 + new_full;
-		u8 *local_buffer = yaffs_get_temp_buffer(dev, __LINE__);
+		u8 *local_buffer = yaffs_get_temp_buffer(dev);
 
 		/* Rewrite the last chunk with its new size and zero pad */
 		yaffs_rd_data_obj(obj, last_chunk, local_buffer);
@@ -3871,7 +3748,7 @@
 		yaffs_wr_data_obj(obj, last_chunk, local_buffer,
 				  new_partial, 1);
 
-		yaffs_release_temp_buffer(dev, local_buffer, __LINE__);
+		yaffs_release_temp_buffer(dev, local_buffer);
 	}
 
 	obj->variant.file_variant.file_size = new_size;
@@ -3882,7 +3759,7 @@
 int yaffs_resize_file(struct yaffs_obj *in, loff_t new_size)
 {
 	struct yaffs_dev *dev = in->my_dev;
-	int old_size = in->variant.file_variant.file_size;
+	loff_t old_size = in->variant.file_variant.file_size;
 
 	yaffs_flush_file_cache(in);
 	yaffs_invalidate_whole_cache(in);
@@ -3919,24 +3796,19 @@
 
 int yaffs_flush_file(struct yaffs_obj *in, int update_time, int data_sync)
 {
-	int ret_val;
-	if (in->dirty) {
-		yaffs_flush_file_cache(in);
-		if (data_sync)	/* Only sync data */
-			ret_val = YAFFS_OK;
-		else {
-			if (update_time)
-				yaffs_load_current_time(in, 0, 0);
+	if (!in->dirty)
+		return YAFFS_OK;
 
-			ret_val = (yaffs_update_oh(in, NULL, 0, 0, 0, NULL) >=
-				   0) ? YAFFS_OK : YAFFS_FAIL;
-		}
-	} else {
-		ret_val = YAFFS_OK;
-	}
+	yaffs_flush_file_cache(in);
 
-	return ret_val;
+	if (data_sync)
+		return YAFFS_OK;
 
+	if (update_time)
+		yaffs_load_current_time(in, 0, 0);
+
+	return (yaffs_update_oh(in, NULL, 0, 0, 0, NULL) >= 0) ?
+				YAFFS_OK : YAFFS_FAIL;
 }
 
 
@@ -3946,7 +3818,6 @@
  */
 static int yaffs_unlink_file_if_needed(struct yaffs_obj *in)
 {
-
 	int ret_val;
 	int del_now = 0;
 	struct yaffs_dev *dev = in->my_dev;
@@ -3971,14 +3842,13 @@
 		    yaffs_change_obj_name(in, in->my_dev->unlinked_dir,
 					  _Y("unlinked"), 0, 0);
 	}
-
 	return ret_val;
 }
 
-int yaffs_del_file(struct yaffs_obj *in)
+static int yaffs_del_file(struct yaffs_obj *in)
 {
 	int ret_val = YAFFS_OK;
-	int deleted;		/* Need to cache value on stack if in is freed */
+	int deleted;	/* Need to cache value on stack if in is freed */
 	struct yaffs_dev *dev = in->my_dev;
 
 	if (dev->param.disable_soft_del || dev->param.is_yaffs2)
@@ -4013,8 +3883,8 @@
 int yaffs_is_non_empty_dir(struct yaffs_obj *obj)
 {
 	return (obj &&
-	        obj->variant_type == YAFFS_OBJECT_TYPE_DIRECTORY) &&
-	        !(list_empty(&obj->variant.dir_variant.children));
+		obj->variant_type == YAFFS_OBJECT_TYPE_DIRECTORY) &&
+		!(list_empty(&obj->variant.dir_variant.children));
 }
 
 static int yaffs_del_dir(struct yaffs_obj *obj)
@@ -4028,8 +3898,7 @@
 
 static int yaffs_del_symlink(struct yaffs_obj *in)
 {
-	if (in->variant.symlink_variant.alias)
-		kfree(in->variant.symlink_variant.alias);
+	kfree(in->variant.symlink_variant.alias);
 	in->variant.symlink_variant.alias = NULL;
 
 	return yaffs_generic_obj_del(in);
@@ -4037,7 +3906,7 @@
 
 static int yaffs_del_link(struct yaffs_obj *in)
 {
-	/* remove this hardlink from the list assocaited with the equivalent
+	/* remove this hardlink from the list associated with the equivalent
 	 * object
 	 */
 	list_del_init(&in->hard_links);
@@ -4047,6 +3916,7 @@
 int yaffs_del_obj(struct yaffs_obj *obj)
 {
 	int ret_val = -1;
+
 	switch (obj->variant_type) {
 	case YAFFS_OBJECT_TYPE_FILE:
 		ret_val = yaffs_del_file(obj);
@@ -4073,20 +3943,20 @@
 		ret_val = 0;
 		break;		/* should not happen. */
 	}
-
 	return ret_val;
 }
 
 static int yaffs_unlink_worker(struct yaffs_obj *obj)
 {
-
 	int del_now = 0;
 
+	if (!obj)
+		return YAFFS_FAIL;
+
 	if (!obj->my_inode)
 		del_now = 1;
 
-	if (obj)
-		yaffs_update_parent(obj->parent);
+	yaffs_update_parent(obj->parent);
 
 	if (obj->variant_type == YAFFS_OBJECT_TYPE_HARDLINK) {
 		return yaffs_del_link(obj);
@@ -4100,7 +3970,7 @@
 		 * Instead, we do the following:
 		 * - Select a hardlink.
 		 * - Unhook it from the hard links
-		 * - Move it from its parent directory (so that the rename can work)
+		 * - Move it from its parent directory so that the rename works.
 		 * - Rename the object to the hardlink's name.
 		 * - Delete the hardlink
 		 */
@@ -4151,21 +4021,19 @@
 		return YAFFS_FAIL;
 	} else {
 		return yaffs_change_obj_name(obj, obj->my_dev->unlinked_dir,
-					     _Y("unlinked"), 0, 0);
-        }
+						_Y("unlinked"), 0, 0);
+	}
 }
 
 static int yaffs_unlink_obj(struct yaffs_obj *obj)
 {
-
 	if (obj && obj->unlink_allowed)
 		return yaffs_unlink_worker(obj);
 
 	return YAFFS_FAIL;
-
 }
 
-int yaffs_unlinker(struct yaffs_obj *dir, const YCHAR * name)
+int yaffs_unlinker(struct yaffs_obj *dir, const YCHAR *name)
 {
 	struct yaffs_obj *obj;
 
@@ -4176,8 +4044,8 @@
 /* Note:
  * If old_name is NULL then we take old_dir as the object to be renamed.
  */
-int yaffs_rename_obj(struct yaffs_obj *old_dir, const YCHAR * old_name,
-		     struct yaffs_obj *new_dir, const YCHAR * new_name)
+int yaffs_rename_obj(struct yaffs_obj *old_dir, const YCHAR *old_name,
+		     struct yaffs_obj *new_dir, const YCHAR *new_name)
 {
 	struct yaffs_obj *obj = NULL;
 	struct yaffs_obj *existing_target = NULL;
@@ -4185,10 +4053,14 @@
 	int result;
 	struct yaffs_dev *dev;
 
-	if (!old_dir || old_dir->variant_type != YAFFS_OBJECT_TYPE_DIRECTORY)
-		YBUG();
-	if (!new_dir || new_dir->variant_type != YAFFS_OBJECT_TYPE_DIRECTORY)
-		YBUG();
+	if (!old_dir || old_dir->variant_type != YAFFS_OBJECT_TYPE_DIRECTORY) {
+		BUG();
+		return YAFFS_FAIL;
+	}
+	if (!new_dir || new_dir->variant_type != YAFFS_OBJECT_TYPE_DIRECTORY) {
+		BUG();
+		return YAFFS_FAIL;
+	}
 
 	dev = old_dir->my_dev;
 
@@ -4197,8 +4069,8 @@
 	 * While look-up is case insensitive, the name isn't.
 	 * Therefore we might want to change x.txt to X.txt
 	 */
-	if (old_dir == new_dir && 
-		old_name && new_name && 
+	if (old_dir == new_dir &&
+		old_name && new_name &&
 		strcmp(old_name, new_name) == 0)
 		force = 1;
 #endif
@@ -4208,26 +4080,24 @@
 		/* ENAMETOOLONG */
 		return YAFFS_FAIL;
 
-	if(old_name)
+	if (old_name)
 		obj = yaffs_find_by_name(old_dir, old_name);
 	else{
 		obj = old_dir;
 		old_dir = obj->parent;
 	}
 
-
 	if (obj && obj->rename_allowed) {
-
-		/* Now do the handling for an existing target, if there is one */
-
+		/* Now handle an existing target, if there is one */
 		existing_target = yaffs_find_by_name(new_dir, new_name);
-		if (yaffs_is_non_empty_dir(existing_target)){
+		if (yaffs_is_non_empty_dir(existing_target)) {
 			return YAFFS_FAIL;	/* ENOTEMPTY */
 		} else if (existing_target && existing_target != obj) {
 			/* Nuke the target first, using shadowing,
 			 * but only if it isn't the same object.
 			 *
-			 * Note we must disable gc otherwise it can mess up the shadowing.
+			 * Note we must disable gc here otherwise it can mess
+			 * up the shadowing.
 			 *
 			 */
 			dev->gc_disable = 1;
@@ -4256,12 +4126,7 @@
 {
 	struct yaffs_obj *obj;
 
-	if (!backward_scanning) {
-		/* Handle YAFFS1 forward scanning case
-		 * For YAFFS1 we always do the deletion
-		 */
-
-	} else {
+	if (backward_scanning) {
 		/* Handle YAFFS2 case (backward scanning)
 		 * If the shadowed object exists then ignore.
 		 */
@@ -4270,7 +4135,8 @@
 			return;
 	}
 
-	/* Let's create it (if it does not exist) assuming it is a file so that it can do shrinking etc.
+	/* Let's create it (if it does not exist) assuming it is a file so that
+	 * it can do shrinking etc.
 	 * We put it in unlinked dir to be cleaned up after the scanning
 	 */
 	obj =
@@ -4280,22 +4146,20 @@
 	obj->is_shadowed = 1;
 	yaffs_add_obj_to_dir(dev->unlinked_dir, obj);
 	obj->variant.file_variant.shrink_size = 0;
-	obj->valid = 1;		/* So that we don't read any other info for this file */
-
+	obj->valid = 1;		/* So that we don't read any other info. */
 }
 
-void yaffs_link_fixup(struct yaffs_dev *dev, struct yaffs_obj *hard_list)
+void yaffs_link_fixup(struct yaffs_dev *dev, struct list_head *hard_list)
 {
+	struct list_head *lh;
+	struct list_head *save;
 	struct yaffs_obj *hl;
 	struct yaffs_obj *in;
 
-	while (hard_list) {
-		hl = hard_list;
-		hard_list = (struct yaffs_obj *)(hard_list->hard_links.next);
-
+	list_for_each_safe(lh, save, hard_list) {
+		hl = list_entry(lh, struct yaffs_obj, hard_links);
 		in = yaffs_find_by_number(dev,
-					  hl->variant.
-					  hardlink_variant.equiv_id);
+					hl->variant.hardlink_variant.equiv_id);
 
 		if (in) {
 			/* Add the hardlink pointers */
@@ -4307,7 +4171,6 @@
 			 */
 			hl->variant.hardlink_variant.equiv_obj = NULL;
 			INIT_LIST_HEAD(&hl->hard_links);
-
 		}
 	}
 }
@@ -4327,19 +4190,14 @@
 	/* Soft delete all the unlinked files */
 	list_for_each_safe(i, n,
 			   &dev->unlinked_dir->variant.dir_variant.children) {
-		if (i) {
-			l = list_entry(i, struct yaffs_obj, siblings);
-			yaffs_del_obj(l);
-		}
+		l = list_entry(i, struct yaffs_obj, siblings);
+		yaffs_del_obj(l);
 	}
 
 	list_for_each_safe(i, n, &dev->del_dir->variant.dir_variant.children) {
-		if (i) {
-			l = list_entry(i, struct yaffs_obj, siblings);
-			yaffs_del_obj(l);
-		}
+		l = list_entry(i, struct yaffs_obj, siblings);
+		yaffs_del_obj(l);
 	}
-
 }
 
 /*
@@ -4350,13 +4208,14 @@
  * - Directly or indirectly under root.
  *
  * Note:
- *  This code assumes that we don't ever change the current relationships between
- *  directories:
+ *  This code assumes that we don't ever change the current relationships
+ *  between directories:
  *   root_dir->parent == unlinked_dir->parent == del_dir->parent == NULL
  *   lost-n-found->parent == root_dir
  *
- * This fixes the problem where directories might have inadvertently been deleted
- * leaving the object "hanging" without being rooted in the directory tree.
+ * This fixes the problem where directories might have inadvertently been
+ * deleted leaving the object "hanging" without being rooted in the
+ * directory tree.
  */
 
 static int yaffs_has_null_parent(struct yaffs_dev *dev, struct yaffs_obj *obj)
@@ -4385,45 +4244,42 @@
 
 	for (i = 0; i < YAFFS_NOBJECT_BUCKETS; i++) {
 		list_for_each_safe(lh, n, &dev->obj_bucket[i].list) {
-			if (lh) {
-				obj =
-				    list_entry(lh, struct yaffs_obj, hash_link);
-				parent = obj->parent;
-
-				if (yaffs_has_null_parent(dev, obj)) {
-					/* These directories are not hanging */
-					hanging = 0;
-				} else if (!parent
-					   || parent->variant_type !=
-					   YAFFS_OBJECT_TYPE_DIRECTORY) {
-					hanging = 1;
-				} else if (yaffs_has_null_parent(dev, parent)) {
-					hanging = 0;
-				} else {
-					/*
-					 * Need to follow the parent chain to see if it is hanging.
-					 */
-					hanging = 0;
-					depth_limit = 100;
+			obj = list_entry(lh, struct yaffs_obj, hash_link);
+			parent = obj->parent;
 
-					while (parent != dev->root_dir &&
-					       parent->parent &&
-					       parent->parent->variant_type ==
-					       YAFFS_OBJECT_TYPE_DIRECTORY
-					       && depth_limit > 0) {
-						parent = parent->parent;
-						depth_limit--;
-					}
-					if (parent != dev->root_dir)
-						hanging = 1;
-				}
-				if (hanging) {
-					yaffs_trace(YAFFS_TRACE_SCAN,
-						"Hanging object %d moved to lost and found",
-						obj->obj_id);
-					yaffs_add_obj_to_dir(dev->lost_n_found,
-							     obj);
+			if (yaffs_has_null_parent(dev, obj)) {
+				/* These directories are not hanging */
+				hanging = 0;
+			} else if (!parent ||
+				   parent->variant_type !=
+				   YAFFS_OBJECT_TYPE_DIRECTORY) {
+				hanging = 1;
+			} else if (yaffs_has_null_parent(dev, parent)) {
+				hanging = 0;
+			} else {
+				/*
+				 * Need to follow the parent chain to
+				 * see if it is hanging.
+				 */
+				hanging = 0;
+				depth_limit = 100;
+
+				while (parent != dev->root_dir &&
+				       parent->parent &&
+				       parent->parent->variant_type ==
+				       YAFFS_OBJECT_TYPE_DIRECTORY &&
+				       depth_limit > 0) {
+					parent = parent->parent;
+					depth_limit--;
 				}
+				if (parent != dev->root_dir)
+					hanging = 1;
+			}
+			if (hanging) {
+				yaffs_trace(YAFFS_TRACE_SCAN,
+					"Hanging object %d moved to lost and found",
+					obj->obj_id);
+				yaffs_add_obj_to_dir(dev->lost_n_found, obj);
 			}
 		}
 	}
@@ -4439,25 +4295,17 @@
 	struct list_head *n;
 
 	if (dir->variant_type != YAFFS_OBJECT_TYPE_DIRECTORY)
-		YBUG();
+		BUG();
 
 	list_for_each_safe(lh, n, &dir->variant.dir_variant.children) {
-		if (lh) {
-			obj = list_entry(lh, struct yaffs_obj, siblings);
-			if (obj->variant_type == YAFFS_OBJECT_TYPE_DIRECTORY)
-				yaffs_del_dir_contents(obj);
-
-			yaffs_trace(YAFFS_TRACE_SCAN,
-				"Deleting lost_found object %d",
-				obj->obj_id);
-
-			/* Need to use UnlinkObject since Delete would not handle
-			 * hardlinked objects correctly.
-			 */
-			yaffs_unlink_obj(obj);
-		}
+		obj = list_entry(lh, struct yaffs_obj, siblings);
+		if (obj->variant_type == YAFFS_OBJECT_TYPE_DIRECTORY)
+			yaffs_del_dir_contents(obj);
+		yaffs_trace(YAFFS_TRACE_SCAN,
+			"Deleting lost_found object %d",
+			obj->obj_id);
+		yaffs_unlink_obj(obj);
 	}
-
 }
 
 static void yaffs_empty_l_n_f(struct yaffs_dev *dev)
@@ -4467,13 +4315,11 @@
 
 
 struct yaffs_obj *yaffs_find_by_name(struct yaffs_obj *directory,
-				     const YCHAR * name)
+				     const YCHAR *name)
 {
 	int sum;
-
 	struct list_head *i;
 	YCHAR buffer[YAFFS_MAX_NAME_LENGTH + 1];
-
 	struct yaffs_obj *l;
 
 	if (!name)
@@ -4483,45 +4329,40 @@
 		yaffs_trace(YAFFS_TRACE_ALWAYS,
 			"tragedy: yaffs_find_by_name: null pointer directory"
 			);
-		YBUG();
+		BUG();
 		return NULL;
 	}
 	if (directory->variant_type != YAFFS_OBJECT_TYPE_DIRECTORY) {
 		yaffs_trace(YAFFS_TRACE_ALWAYS,
 			"tragedy: yaffs_find_by_name: non-directory"
 			);
-		YBUG();
+		BUG();
 	}
 
 	sum = yaffs_calc_name_sum(name);
 
 	list_for_each(i, &directory->variant.dir_variant.children) {
-		if (i) {
-			l = list_entry(i, struct yaffs_obj, siblings);
+		l = list_entry(i, struct yaffs_obj, siblings);
 
-			if (l->parent != directory)
-				YBUG();
+		if (l->parent != directory)
+			BUG();
 
-			yaffs_check_obj_details_loaded(l);
+		yaffs_check_obj_details_loaded(l);
 
-			/* Special case for lost-n-found */
-			if (l->obj_id == YAFFS_OBJECTID_LOSTNFOUND) {
-				if (!strcmp(name, YAFFS_LOSTNFOUND_NAME))
-					return l;
-			} else if (l->sum == sum
-				   || l->hdr_chunk <= 0) {
-				/* LostnFound chunk called Objxxx
-				 * Do a real check
-				 */
-				yaffs_get_obj_name(l, buffer,
-						   YAFFS_MAX_NAME_LENGTH + 1);
-				if (strncmp
-				    (name, buffer, YAFFS_MAX_NAME_LENGTH) == 0)
-					return l;
-			}
+		/* Special case for lost-n-found */
+		if (l->obj_id == YAFFS_OBJECTID_LOSTNFOUND) {
+			if (!strcmp(name, YAFFS_LOSTNFOUND_NAME))
+				return l;
+		} else if (l->sum == sum || l->hdr_chunk <= 0) {
+			/* LostnFound chunk called Objxxx
+			 * Do a real check
+			 */
+			yaffs_get_obj_name(l, buffer,
+				YAFFS_MAX_NAME_LENGTH + 1);
+			if (!strncmp(name, buffer, YAFFS_MAX_NAME_LENGTH))
+				return l;
 		}
 	}
-
 	return NULL;
 }
 
@@ -4532,7 +4373,6 @@
 struct yaffs_obj *yaffs_get_equivalent_obj(struct yaffs_obj *obj)
 {
 	if (obj && obj->variant_type == YAFFS_OBJECT_TYPE_HARDLINK) {
-		/* We want the object id of the equivalent object, not this one */
 		obj = obj->variant.hardlink_variant.equiv_obj;
 		yaffs_check_obj_details_loaded(obj);
 	}
@@ -4552,13 +4392,13 @@
  * system to share files.
  *
  * These automatic unicode are stored slightly differently...
- *  - If the name can fit in the ASCII character space then they are saved as 
+ *  - If the name can fit in the ASCII character space then they are saved as
  *    ascii names as per above.
  *  - If the name needs Unicode then the name is saved in Unicode
  *    starting at oh->name[1].
 
  */
-static void yaffs_fix_null_name(struct yaffs_obj *obj, YCHAR * name,
+static void yaffs_fix_null_name(struct yaffs_obj *obj, YCHAR *name,
 				int buffer_size)
 {
 	/* Create an object name if we could not find one. */
@@ -4580,23 +4420,17 @@
 	}
 }
 
-int yaffs_get_obj_name(struct yaffs_obj *obj, YCHAR * name, int buffer_size)
+int yaffs_get_obj_name(struct yaffs_obj *obj, YCHAR *name, int buffer_size)
 {
 	memset(name, 0, buffer_size * sizeof(YCHAR));
-
 	yaffs_check_obj_details_loaded(obj);
-
 	if (obj->obj_id == YAFFS_OBJECTID_LOSTNFOUND) {
 		strncpy(name, YAFFS_LOSTNFOUND_NAME, buffer_size - 1);
-	}
-#ifndef CONFIG_YAFFS_NO_SHORT_NAMES
-	else if (obj->short_name[0]) {
+	} else if (obj->short_name[0]) {
 		strcpy(name, obj->short_name);
-	}
-#endif
-	else if (obj->hdr_chunk > 0) {
+	} else if (obj->hdr_chunk > 0) {
 		int result;
-		u8 *buffer = yaffs_get_temp_buffer(obj->my_dev, __LINE__);
+		u8 *buffer = yaffs_get_temp_buffer(obj->my_dev);
 
 		struct yaffs_obj_hdr *oh = (struct yaffs_obj_hdr *)buffer;
 
@@ -4610,7 +4444,7 @@
 		yaffs_load_name_from_oh(obj->my_dev, name, oh->name,
 					buffer_size);
 
-		yaffs_release_temp_buffer(obj->my_dev, buffer, __LINE__);
+		yaffs_release_temp_buffer(obj->my_dev, buffer);
 	}
 
 	yaffs_fix_null_name(obj, name, buffer_size);
@@ -4618,7 +4452,7 @@
 	return strnlen(name, YAFFS_MAX_NAME_LENGTH);
 }
 
-int yaffs_get_obj_length(struct yaffs_obj *obj)
+loff_t yaffs_get_obj_length(struct yaffs_obj *obj)
 {
 	/* Dereference any hard linking */
 	obj = yaffs_get_equivalent_obj(obj);
@@ -4683,6 +4517,8 @@
 			return DT_BLK;
 		if (S_ISSOCK(obj->yst_mode))
 			return DT_SOCK;
+		return DT_REG;
+		break;
 	default:
 		return DT_REG;
 		break;
@@ -4702,13 +4538,10 @@
 
 static int yaffs_check_dev_fns(const struct yaffs_dev *dev)
 {
-
 	/* Common functions, gotta have */
 	if (!dev->param.erase_fn || !dev->param.initialise_flash_fn)
 		return 0;
 
-#ifdef CONFIG_YAFFS_YAFFS2
-
 	/* Can use the "with tags" style interface for yaffs1 or yaffs2 */
 	if (dev->param.write_chunk_tags_fn &&
 	    dev->param.read_chunk_tags_fn &&
@@ -4716,7 +4549,6 @@
 	    !dev->param.read_chunk_fn &&
 	    dev->param.bad_block_fn && dev->param.query_block_fn)
 		return 1;
-#endif
 
 	/* Can use the "spare" style interface for yaffs1 */
 	if (!dev->param.is_yaffs2 &&
@@ -4732,17 +4564,13 @@
 
 static int yaffs_create_initial_dir(struct yaffs_dev *dev)
 {
-	/* Initialise the unlinked, deleted, root and lost and found directories */
-
+	/* Initialise the unlinked, deleted, root and lost+found directories */
 	dev->lost_n_found = dev->root_dir = NULL;
 	dev->unlinked_dir = dev->del_dir = NULL;
-
 	dev->unlinked_dir =
 	    yaffs_create_fake_dir(dev, YAFFS_OBJECTID_UNLINKED, S_IFDIR);
-
 	dev->del_dir =
 	    yaffs_create_fake_dir(dev, YAFFS_OBJECTID_DELETED, S_IFDIR);
-
 	dev->root_dir =
 	    yaffs_create_fake_dir(dev, YAFFS_OBJECTID_ROOT,
 				  YAFFS_ROOT_MODE | S_IFDIR);
@@ -4755,7 +4583,6 @@
 		yaffs_add_obj_to_dir(dev->root_dir, dev->lost_n_found);
 		return YAFFS_OK;
 	}
-
 	return YAFFS_FAIL;
 }
 
@@ -4765,7 +4592,7 @@
 	unsigned x;
 	int bits;
 
-	yaffs_trace(YAFFS_TRACE_TRACING, "yaffs: yaffs_guts_initialise()" );
+	yaffs_trace(YAFFS_TRACE_TRACING, "yaffs: yaffs_guts_initialise()");
 
 	/* Check stuff that must be set */
 
@@ -4776,6 +4603,11 @@
 		return YAFFS_FAIL;
 	}
 
+	if (dev->is_mounted) {
+		yaffs_trace(YAFFS_TRACE_ALWAYS, "device already mounted");
+		return YAFFS_FAIL;
+	}
+
 	dev->internal_start_block = dev->param.start_block;
 	dev->internal_end_block = dev->param.end_block;
 	dev->block_offset = 0;
@@ -4800,9 +4632,9 @@
 		(dev->param.inband_tags && !dev->param.is_yaffs2) ||
 		 dev->param.chunks_per_block < 2 ||
 		 dev->param.n_reserved_blocks < 2 ||
-		dev->internal_start_block <= 0 || 
-		dev->internal_end_block <= 0 || 
-		dev->internal_end_block <= 
+		dev->internal_start_block <= 0 ||
+		dev->internal_end_block <= 0 ||
+		dev->internal_end_block <=
 		(dev->internal_start_block + dev->param.n_reserved_blocks + 2)
 		) {
 		/* otherwise it is too small */
@@ -4836,12 +4668,7 @@
 		return YAFFS_FAIL;
 	}
 
-	if (dev->is_mounted) {
-		yaffs_trace(YAFFS_TRACE_ALWAYS, "device already mounted");
-		return YAFFS_FAIL;
-	}
-
-	/* Finished with most checks. One or two more checks happen later on too. */
+	/* Finished with most checks. Further checks happen later on too. */
 
 	dev->is_mounted = 1;
 
@@ -4878,7 +4705,7 @@
 			dev->tnode_width = bits;
 	} else {
 		dev->tnode_width = 16;
-        }
+	}
 
 	dev->tnode_mask = (1 << dev->tnode_width) - 1;
 
@@ -4909,7 +4736,7 @@
 		return YAFFS_FAIL;
 	}
 
-	/* OK, we've finished verifying the device, lets continue with initialisation */
+	/* Finished verifying the device, continue with initialisation */
 
 	/* More device initialisation */
 	dev->all_gcs = 0;
@@ -4929,7 +4756,8 @@
 	dev->n_erase_failures = 0;
 	dev->n_erased_blocks = 0;
 	dev->gc_disable = 0;
-	dev->has_pending_prioritised_gc = 1;	/* Assume the worst for now, will get fixed on first GC */
+	dev->has_pending_prioritised_gc = 1;
+		/* Assume the worst for now, will get fixed on first GC */
 	INIT_LIST_HEAD(&dev->dirty_dirs);
 	dev->oldest_dirty_seq = 0;
 	dev->oldest_dirty_block = 0;
@@ -4991,18 +4819,24 @@
 	if (!init_failed && !yaffs_create_initial_dir(dev))
 		init_failed = 1;
 
+	if (!init_failed && dev->param.is_yaffs2 &&
+		!dev->param.disable_summary &&
+		!yaffs_summary_init(dev))
+		init_failed = 1;
+
 	if (!init_failed) {
 		/* Now scan the flash. */
 		if (dev->param.is_yaffs2) {
 			if (yaffs2_checkpt_restore(dev)) {
 				yaffs_check_obj_details_loaded(dev->root_dir);
-				yaffs_trace(YAFFS_TRACE_CHECKPOINT | YAFFS_TRACE_MOUNT,
+				yaffs_trace(YAFFS_TRACE_CHECKPOINT |
+					YAFFS_TRACE_MOUNT,
 					"yaffs: restored from checkpoint"
 					);
 			} else {
 
-				/* Clean up the mess caused by an aborted checkpoint load
-				 * and scan backwards.
+				/* Clean up the mess caused by an aborted
+				 * checkpoint load then scan backwards.
 				 */
 				yaffs_deinit_blocks(dev);
 
@@ -5030,7 +4864,7 @@
 			}
 		} else if (!yaffs1_scan(dev)) {
 			init_failed = 1;
-                }
+		}
 
 		yaffs_strip_deleted_objs(dev);
 		yaffs_fix_hanging_objs(dev);
@@ -5052,7 +4886,7 @@
 	dev->n_page_writes = 0;
 	dev->n_erasures = 0;
 	dev->n_gc_copies = 0;
-	dev->n_retired_writes = 0;
+	dev->n_retried_writes = 0;
 
 	dev->n_retired_blocks = 0;
 
@@ -5066,7 +4900,6 @@
 	yaffs_trace(YAFFS_TRACE_TRACING,
 	  "yaffs: yaffs_guts_initialise() done.");
 	return YAFFS_OK;
-
 }
 
 void yaffs_deinitialise(struct yaffs_dev *dev)
@@ -5076,11 +4909,12 @@
 
 		yaffs_deinit_blocks(dev);
 		yaffs_deinit_tnodes_and_objs(dev);
+		yaffs_summary_deinit(dev);
+
 		if (dev->param.n_caches > 0 && dev->cache) {
 
 			for (i = 0; i < dev->param.n_caches; i++) {
-				if (dev->cache[i].data)
-					kfree(dev->cache[i].data);
+				kfree(dev->cache[i].data);
 				dev->cache[i].data = NULL;
 			}
 
@@ -5104,7 +4938,6 @@
 {
 	int n_free = 0;
 	int b;
-
 	struct yaffs_block_info *blk;
 
 	blk = dev->block_info;
@@ -5123,14 +4956,12 @@
 		}
 		blk++;
 	}
-
 	return n_free;
 }
 
 int yaffs_get_n_free_chunks(struct yaffs_dev *dev)
 {
 	/* This is what we report to the outside world */
-
 	int n_free;
 	int n_dirty_caches;
 	int blocks_for_checkpt;
@@ -5139,7 +4970,7 @@
 	n_free = dev->n_free_chunks;
 	n_free += dev->n_deleted_files;
 
-	/* Now count the number of dirty chunks in the cache and subtract those */
+	/* Now count and subtract the number of dirty chunks in the cache. */
 
 	for (n_dirty_caches = 0, i = 0; i < dev->param.n_caches; i++) {
 		if (dev->cache[i].dirty)
@@ -5151,7 +4982,7 @@
 	n_free -=
 	    ((dev->param.n_reserved_blocks + 1) * dev->param.chunks_per_block);
 
-	/* Now we figure out how much to reserve for the checkpoint and report that... */
+	/* Now figure checkpoint space and report that... */
 	blocks_for_checkpt = yaffs_calc_checkpt_blocks_required(dev);
 
 	n_free -= (blocks_for_checkpt * dev->param.chunks_per_block);
@@ -5160,5 +4991,63 @@
 		n_free = 0;
 
 	return n_free;
+}
+
+
+int yaffs_format_dev(struct yaffs_dev *dev)
+{
+	int i;
+	enum yaffs_block_state state;
+	u32 dummy;
 
+	if(dev->is_mounted)
+		return YAFFS_FAIL;
+
+	/*
+	* The runtime variables might not have been set up,
+	* so set up what we need.
+	*/
+	dev->internal_start_block = dev->param.start_block;
+	dev->internal_end_block = dev->param.end_block;
+	dev->block_offset = 0;
+	dev->chunk_offset = 0;
+
+	if (dev->param.start_block == 0) {
+		dev->internal_start_block = dev->param.start_block + 1;
+		dev->internal_end_block = dev->param.end_block + 1;
+		dev->block_offset = 1;
+		dev->chunk_offset = dev->param.chunks_per_block;
+	}
+
+	for (i = dev->internal_start_block; i <= dev->internal_end_block; i++) {
+		yaffs_query_init_block_state(dev, i, &state, &dummy);
+		if (state != YAFFS_BLOCK_STATE_DEAD)
+			yaffs_erase_block(dev, i);
+	}
+
+	return YAFFS_OK;
+}
+
+
+/*
+ * Marshalling functions to get loff_t file sizes into and out of
+ * object headers.
+ */
+void yaffs_oh_size_load(struct yaffs_obj_hdr *oh, loff_t fsize)
+{
+	oh->file_size_low = (fsize & 0xFFFFFFFF);
+	oh->file_size_high = ((fsize >> 32) & 0xFFFFFFFF);
+}
+
+loff_t yaffs_oh_to_size(struct yaffs_obj_hdr *oh)
+{
+	loff_t retval;
+
+	if (sizeof(loff_t) >= 8 && ~(oh->file_size_high))
+		retval = (((loff_t) oh->file_size_high) << 32) |
+			(((loff_t) oh->file_size_low) & 0xFFFFFFFF);
+	else
+		retval = (loff_t) oh->file_size_low;
+
+	return retval;
 }
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/fs/yaffs2/yaffs_guts.h linux-linaro-3.4-2012.05-1_cavium/fs/yaffs2/yaffs_guts.h
